"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseUrl = exports.parseResponse = void 0;
var url_1 = require("url");
var querystring_1 = __importDefault(require("querystring"));
var parseResponse = function (status, body) {
    var result = { status: status };
    if (!body) {
        result.body = '';
    }
    else {
        try {
            var json = JSON.parse(body);
            result.data = json;
        }
        catch (_a) {
            result.body = body;
        }
    }
    return result;
};
exports.parseResponse = parseResponse;
var parseUrl = function (url, params) {
    var urlData = new url_1.URL(url);
    var path = urlData.pathname;
    if (params) {
        path += '?' + querystring_1.default.encode(params);
    }
    return {
        hostname: urlData.hostname,
        path: path,
    };
};
exports.parseUrl = parseUrl;
